#include <porty/c99tree-cc/c99tree-cc.h>

/* ---- public ---- */

#define LOADER_MAXLEVEL 512

/* generic loader */
c99c_node_t *c99c_tree_load(c99tree_cc_t *ctx, const char *filename, const char *format);

/* generic loader cleanup */
void c99c_tree_load_cleanup(c99tree_cc_t *ctx, const char *format);

/* ---- internal ---- */

/* per file format loaders */
c99c_node_t *c99c_tree_load_c(c99tree_cc_t *ctx, const char *filename);
c99c_node_t *c99c_tree_load_ind(c99tree_cc_t *ctx, const char *filename);
c99c_node_t *c99c_tree_load_xml(c99tree_cc_t *ctx, const char *filename);

/* per file format cleanup functions */
void c99c_tree_load_cleanup_c(c99tree_cc_t *ctx);
